# -*- coding: utf-8 -*-

import sys

try:
    import scribus
except ImportError,err:
    print("This Python script is written for the Scribus scripting interface and can only be run from within Scribus.")
    sys.exit(1)
    
if scribus.haveDoc():

    from grid_config import *

    
    # # Positions
    # x_start, x_end = 30, 190# 20,3.5
    # y_start, y_end = 50, 250# 62, 13
    # # vertical space between lines
    # space_v = 6
    # # horizontal space between lines
    # space_h = 5
    
    # # widths of vertical lines
    # lw_vert = (0.8, 0.05, 0.05, 0.05, 0.05, 0.05, 0.4, 0.05, 0.05, 0.05, 0.05, 0.05)
    # # widths of horizontal lines
    # lw_horiz = (0.4, 0.05, 0.05, 0.05, 0.05)
    # # labels of vertical lines : text, y position
    # l_vert_label_text = [""] + list(range(5, 60, 5))
    # l_vert_label_y = y_start - 10
    # l_vert_label_fontsize = 7
    # # labels of horizontal lines : text, x position
    # l_horiz_label_text = range(250, 0, -10)
    # l_horiz_label_x = x_start - 10
    # l_horiz_label_fontsize = 11
    
    # # Fill color of horizontal spaces
    # space_h_colors = ("gris_5", None, "gris_5", None, "gris_5", None, "gris_5", None, "gris_5", None,
    # "gris_25", "gris_30", "gris_25", "gris_30", "gris_25", "gris_30", "gris_25", "gris_30", "gris_25", "gris_30",
    # None, "gris_5", None, "gris_5", None)

    
    # Colors
    avail_colors = scribus.getColorNames()
    C, M, Y, K = 0, 0, 0, 0
    for c in set(conf[CONF_ID]["space"]["horiz_colors"]):
        if c and c not in avail_colors:
            c_attr = c.split("_")
            if c_attr[0] == "gris":
                C, M, Y = 0, 0, 0
            # define other colors here ...
            K = int(int(c_attr[1]) * 255 / 100)
            scribus.defineColor(c, C, M, Y, K)
            
    
    # Number of points per mm
    PT_PER_MM = 2.8346
    

    # if scribus.selectionCount() == 0:
    #     scribus.messageBox("Scribus - Script Error", "There is no object selected. Please select a text frame and try again.", scribus.ICON_WARNING, scribus.BUTTON_OK)
    #     sys.exit(2)
    # if scribus.selectionCount() > 1:
    #     scribus.messageBox("Scribus - Script Error","You have more than one object selected. Please select one text frame and try again.", scribus.ICON_WARNING, scribus.BUTTON_OK)
    #     sys.exit(2)
    # selected_frame = scribus.getSelectedObject()
    
    # width, height = scribus.getSize(selected_frame)
    # x_orig, y_orig = scribus.getPosition(selected_frame)

    # Computed parameters
    width_tot = conf[CONF_ID]["coord"]["x_end"] - conf[CONF_ID]["coord"]["x_start"]
    height_tot = conf[CONF_ID]["coord"]["y_end"] - conf[CONF_ID]["coord"]["y_start"]

    lw_horiz_l = len(conf[CONF_ID]["linewidth"]["horiz"])
    lw_vert_l = len(conf[CONF_ID]["linewidth"]["vert"])
    ylab_text_l = 0
    if conf[CONF_ID]["ylab"]["text"]:
        ylab_text_l = len(conf[CONF_ID]["ylab"]["text"])
    xlab_text_l = 0
    if conf[CONF_ID]["xlab"]["text"]:
        xlab_text_l = len(conf[CONF_ID]["xlab"]["text"])
    space_h_colors_l = 0
    if conf[CONF_ID]["space"]["horiz_colors"]:
        space_h_colors_l = len(conf[CONF_ID]["space"]["horiz_colors"])

    # Drawing horizontal lines +/- fill colors
    y = conf[CONF_ID]["coord"]["y_start"]
    i = 0
    while y <= conf[CONF_ID]["coord"]["y_end"]:
        # Colored rectangle first (background)
        if conf[CONF_ID]["space"]["horiz_colors"][i % space_h_colors_l]:
            r = scribus.createRect(conf[CONF_ID]["coord"]["x_start"],
                                   y,
                                   width_tot,
                                   conf[CONF_ID]["space"]["vert"])
            scribus.setFillColor(conf[CONF_ID]["space"]["horiz_colors"][i % space_h_colors_l],
                                 r)
            scribus.setLineColor(conf[CONF_ID]["space"]["horiz_colors"][i % space_h_colors_l],
                                 r)
            # scribus.setLineTransparency(1, r)
            
        # Then line (foreground)
        # Check if line should be drawn (line width > 0)
        if conf[CONF_ID]["linewidth"]["horiz"][i % lw_horiz_l]:
            l = scribus.createLine(conf[CONF_ID]["coord"]["x_start"],
                                      y,
                                      conf[CONF_ID]["coord"]["x_end"],
                                      y)
            scribus.setLineWidth(conf[CONF_ID]["linewidth"]["horiz"][i % lw_horiz_l] * PT_PER_MM,
                                 l)
        # Label
        if conf[CONF_ID]["ylab"]["text"]:
            t = scribus.createText(conf[CONF_ID]["ylab"]["x"],
                                   y - conf[CONF_ID]["space"]["vert"] / 2,
                                   abs(conf[CONF_ID]["coord"]["x_start"] - conf[CONF_ID]["ylab"]["x"]),
                                   conf[CONF_ID]["space"]["vert"])
            scribus.setTextDistances(1, 1, 1, 1, t)
            scribus.setTextVerticalAlignment(scribus.ALIGNV_CENTERED, t)
            scribus.setTextAlignment(scribus.ALIGN_RIGHT, t)
            scribus.insertText(str(conf[CONF_ID]["ylab"]["text"][i % ylab_text_l]), 0, t)
            scribus.setFontSize(conf[CONF_ID]["ylab"]["fontsize"], t)
        
        y += conf[CONF_ID]["space"]["vert"]
        i += 1        

    # Drawing vertical lines
    x = conf[CONF_ID]["coord"]["x_start"]
    i = 0
    x_shift = 0
    if "x_shift" in conf[CONF_ID]["space"].keys():
        x_shift = conf[CONF_ID]["space"]["x_shift"]
    while x <= conf[CONF_ID]["coord"]["x_end"]:
        # Check if line should be drawn (line width > 0)
        if conf[CONF_ID]["linewidth"]["vert"][i % lw_vert_l]:
            # Line
            l = scribus.createLine(x + x_shift,
                               conf[CONF_ID]["coord"]["y_start"],
                                   x,
                                   conf[CONF_ID]["coord"]["y_end"])
            scribus.setLineWidth(conf[CONF_ID]["linewidth"]["vert"][i % lw_vert_l] * PT_PER_MM,
                                 l)
        # Label
        if conf[CONF_ID]["xlab"]["text"]:
            t = scribus.createText(x - conf[CONF_ID]["space"]["horiz"] / 2,
                                   conf[CONF_ID]["xlab"]["y"],
                                   conf[CONF_ID]["space"]["horiz"],
                                   abs(conf[CONF_ID]["coord"]["y_start"] - conf[CONF_ID]["xlab"]["y"]))
            scribus.setTextDistances(0.5, 0.5, 0.5, 0.5, t)
            scribus.setTextVerticalAlignment(scribus.ALIGNV_BOTTOM, t)
            scribus.setTextAlignment(scribus.ALIGN_CENTERED, t)
            scribus.insertText(str(conf[CONF_ID]["xlab"]["text"][i % xlab_text_l]), 0, t)
            scribus.setFontSize(conf[CONF_ID]["xlab"]["fontsize"], t)

        x += conf[CONF_ID]["space"]["horiz"]
        i += 1

    # scribus.messageBox("OK", "Done ",
    #                    scribus.ICON_NONE, scribus.BUTTON_OK)
    sys.exit(0)
else:
    scribus.messageBox("Usage Error", "You need a Document open", scribus.ICON_WARNING, scribus.BUTTON_OK)
    sys.exit(2)
