# -*- coding: utf-8 -*-

# Configuration to load
CONF_ID = "4"

######
# Common configuration parameters

# Horizontal space for unit period
HORIZ_SPACE = 4.88

# x-position of left side of grid
# X_START = 70
X_START = 210

# Number of unit periods in the grid
# NB_UNIT_PERIOD = 69
NB_UNIT_PERIOD = 84


conf = {
    # Paramètres vitaux graphiques
    "1": {
        "coord": {
	    "x_start": X_START,
	    "x_end": X_START + NB_UNIT_PERIOD * HORIZ_SPACE,
	    "y_start": 33,
	    "y_end": 137
        },
        "space": {
	    "vert": 4,
	    "horiz": HORIZ_SPACE,
            "horiz_colors": ("gris_5", None, "gris_5", None, "gris_5", None, "gris_5", None, "gris_5", None,
                             "gris_25", "gris_30", "gris_25", "gris_30", "gris_25", "gris_30", "gris_25", "gris_30", "gris_25", "gris_30",
                             None, "gris_5", None, "gris_5", None)
        },
        "linewidth": {
	    "vert": (0.8, 0.05, 0.05, 0.05, 0.05, 0.05, 0.4, 0.05, 0.05, 0.05, 0.05, 0.05),
	    "horiz": (0.05, 0.4, 0.05, 0.05, 0.05)
        },
        "xlab": {
	    "text": [""] + list(range(5, 60, 5)),
            "y": 30,
            "fontsize": 7
        },
        "ylab": {
	    "text": range(260, 0, -10),
            "x": X_START - 9,
            "fontsize": 7
        }
    },
    # Paramètres numériques
    "2": {
        "coord": {
	    "x_start": X_START,
	    "x_end": X_START + NB_UNIT_PERIOD * HORIZ_SPACE,
	    "y_start": 137,
	    "y_end": 239
            # "y_end": 209
        },
        "space": {
	    "vert": 6,
	    "horiz": 3 * HORIZ_SPACE,
            "horiz_colors": (None,)
        },
        "linewidth": {
	    "vert": (0.8, 0.05, 0.4, 0.05),
	    "horiz": (0.1,)
        },
        "xlab": {
	    "text": None,
            "y": 40,
            "fontsize": 7
        },
        "ylab": {
	    "text": None,
            "x": 20,
            "fontsize": 10
        }
    },
    # Injections et persfusions
    "3": {
        "coord": {
	    "x_start": X_START,
	    "x_end": X_START + NB_UNIT_PERIOD * HORIZ_SPACE,
	    "y_start": 239,
            # "y_start": 209,
	    "y_end": 287
        },
        "space": {
	    "vert": 100,
            # "vert": 6,
	    "horiz": 6 * HORIZ_SPACE,
            # "horiz": HORIZ_SPACE,
            "horiz_colors": (None,)
        },
        "linewidth": {
	    "vert": (0.8, 0.4),
            #"vert": (0.8, 0.02, 0.02, 0.02, 0.02, 0.02, 0.4, 0.02, 0.02, 0.02, 0.02, 0.02),
	    "horiz": (0.02,)
        },
        "xlab": {
	    "text": None,
            "y": 40,
            "fontsize": 7
        },
        "ylab": {
	    "text": None,
            "x": 20,
            "fontsize": 10
        }
    },
    # Temps opératoires (traits penchés)
    "4": {
        "coord": {
	    "x_start": X_START + HORIZ_SPACE,
	    "x_end": X_START + NB_UNIT_PERIOD * HORIZ_SPACE - HORIZ_SPACE,
	    "y_start": 10,
            # "y_start": 209,
	    "y_end": 27
        },
        "space": {
	    "vert": 100,
            # "vert": 6,
	    "horiz": HORIZ_SPACE,
            # "horiz": HORIZ_SPACE,
            "x_shift": 12,
            "horiz_colors": (None,)
        },
        "linewidth": {
	    "vert": (0.05,),
            #"vert": (0.8, 0.02, 0.02, 0.02, 0.02, 0.02, 0.4, 0.02, 0.02, 0.02, 0.02, 0.02),
	    "horiz": (0,)
        },
        "xlab": {
	    "text": None,
            "y": 40,
            "fontsize": 7
        },
        "ylab": {
	    "text": None,
            "x": 20,
            "fontsize": 10
        }
    },
    # Temps opératoires (jonctions verticales avec la grille)
    "5": {
        "coord": {
	    "x_start": X_START + HORIZ_SPACE,
	    "x_end": X_START + NB_UNIT_PERIOD * HORIZ_SPACE - HORIZ_SPACE,
	    "y_start": 27,
            # "y_start": 209,
	    "y_end": 30
        },
        "space": {
	    "vert": 100,
            # "vert": 6,
	    "horiz": HORIZ_SPACE,
            # "horiz": HORIZ_SPACE,
            "horiz_colors": (None,)
        },
        "linewidth": {
	    "vert": (0.05,),
            #"vert": (0.8, 0.02, 0.02, 0.02, 0.02, 0.02, 0.4, 0.02, 0.02, 0.02, 0.02, 0.02),
	    "horiz": (0,)
        },
        "xlab": {
	    "text": None,
            "y": 40,
            "fontsize": 7
        },
        "ylab": {
	    "text": None,
            "x": 20,
            "fontsize": 10
        }
    }
}
